<?php
/*
  Plugin Name: Dargahbank
  Plugin URI: https://dargahbank.ir
  Description: دانلود به ازا پرداخت درگاه بانک نسخه بدون ایمیل
  Version: 1.3
  Author: MOHAMMAD REZA BEHZADFAR
  Author URI: http://m-behzadfar.ir
  License: GPL2
 */
 //ips change
DPFileDownload::init();

class DPFileDownload {

    protected static $currencies = array(
        'USD' => array('United States Dollar', '$'),
        'AUD' => array('Australian Dollar', 'AUD$'),
        'BRL' => array('Brazilian Real', 'R$'),
        'GBP' => array('British Pound', '&pound;'),
        'CAD' => array('Canadian Dollar', 'CAD$'),
        'CNY' => array('Chinese Yuan', '&#20803;'),
        'DKK' => array('Danish Krone', 'kr.'),
        'EUR' => array('European Euro', '&#8364;'),
        'HKD' => array('Hong Kong Dollar', 'HK$'),
        'HUF' => array('Hungarian Forint', 'Ft'),
        'INR' => array('Indian Rupee', 'INR'),
        'IDR' => array('Indonesian Rupiah', 'Rp'),
        'JPY' => array('Japanese Yen', '&yen;'),
        'MXN' => array('Mexican Peso', 'MEX$'),
        'NZD' => array('New Zealand Dollar', 'NZ$'),
        'NOK' => array('Norwegian Kroner', 'kr'),
        'PLN' => array('Polish Zloty', 'zl.'),
        'RUB' => array('Russian Ruble', 'RUB'),
        'SAR' => array('Saudi Riyal', 'SR'),
        'SGD' => array('Singapore Dollar', 'SGD$'),
        'ZAR' => array('South African Rand', 'R'),
        'SEK' => array('Swedish Krona', 'kr'),
        'CHF' => array('Swiss Franc', 'CHF'),
        'THB' => array('Thai Bhat', '&#3647;'),
        'TRY' => array('Turkish Lira', 'TRY'),
        'TWD' => array('Taiwan Dollar', 'TWD')
    );

    const VERSION = '1.3';
    const DB_VERSION = "1.0";

    public static function init() {
        register_activation_hook(__FILE__, array(__CLASS__, 'install'));

        // admin stuff
        add_action('admin_menu', array(__CLASS__, 'admin_menu'));
        add_action('admin_init', array(__CLASS__, 'admin_init'));

        // media buttons hook
        add_action('media_buttons_context', array(__CLASS__, 'media_button'));

        // insert form
        add_action('admin_footer', array(__CLASS__, 'add_pd_pfd_form'));

        // listener for ipn activation
        add_action('template_redirect', array(__CLASS__, 'var_listener'));
        add_filter('query_vars', array(__CLASS__, 'register_vars'));

        add_action('admin_menu', array(__CLASS__, 'add_meta_box'));
    }

    protected static function transactioncode($length = "") {
        $code = md5(uniqid(rand(), true));
        if ($length != "")
            return strtoupper(substr($code, 0, $length));
        else
            return strtoupper($code);
    }

	
	
	
	
	
	
    protected static function relative_time($ptime) {
        $etime = time() - $ptime;

        if ($etime < 1) {
            return '0 seconds';
        }

        $a = array(12 * 30 * 24 * 60 * 60 => 'year',
            30 * 24 * 60 * 60 => 'month',
            24 * 60 * 60 => 'day',
            60 * 60 => 'hour',
            60 => 'minute',
            1 => 'second'
        );

        foreach ($a as $secs => $str) {
            $d = $etime / $secs;
            if ($d >= 1) {
                $r = round($d);
                return $r . ' ' . $str . ($r > 1 ? 's' : '');
            }
        }
    }

    public static function add_meta_box() {
        add_meta_box('pd_pfd_sectionid', "پرداخت به ازای دانلود درگاه بانک", array(__CLASS__, 'meta_box'), 'post', 'side', 'high');
        add_meta_box('pd_pfd_sectionid', "پرداخت به ازای دانلود درگاه بانک", array(__CLASS__, 'meta_box'), 'page', 'side', 'high');
    }

    public static function meta_box() {
//		echo '<div style="margin-top:5px;margin-bottom:5px;">';
        echo '<a href="#TB_inline?width=450&inlineId=dp_paypal_file_download_form" class="thickbox button" title="قرار دادن لینک پرداخت">قرار دادن لینک پرداخت</a>';
//		echo '</div>';
    }

    public static function install() {
        global $wpdb;

        $message_default = <<<EOT
بابت خريد محصول [PRODUCT_NAME] تشکر مي کنيم! لينک دانلود در انتهاي  اين پيغام قرار گرفته. براي پيگيري هاي بعدي شماره تراکنش [TRANSACTION_ID] را يادداشت نماييد.
EOT;

        $message_default_nofile = <<<EOT
بابت خريد محصول [PRODUCT_NAME] تشکر مي کنيم! لينک دانلود در انتهاي  اين پيغام قرار گرفته. براي پيگيري هاي بعدي شماره تراکنش [TRANSACTION_ID] را يادداشت نماييد.
EOT;

        add_option("pd_pd_email_message", $message_default, '', 'yes');
        add_option("pd_pd_email_message_nofile", $message_default_nofile, '', 'yes');
        add_option("pd_expire_links_after", 7, '', 'yes');
        add_option("pd_paypal_email", "XXXX-XXXXX-XXXX-XXXXX-XXXX", '', 'yes');
        add_option("pd_pd_paypal_direct", 0, '', 'yes');
        add_option("pd_paypal_return_url", get_option("siteurl"), '', 'yes');
        add_option("pd_get_hamrah", '0', '', 'yes');

        add_option("vip_pasargad_terminal", "YOUR-terminal-id", '', 'yes');
        add_option("vip_pasargad_username", "YOUR-username-id", '', 'yes');
        add_option("vip_manba_username", "YOUR-terminal-id", '', 'yes');

        add_option("dargah_type", "YOUR-type", '', 'yes');

        add_option("vip_mellat_terminal", "YOUR-terminal-id", '', 'yes');
        add_option("vip_mellat_username", "YOUR-Mellat-username", '', 'yes');
        add_option("vip_mellat_password", "YOUR-Mellat-password", '', 'yes');

        $table_name = $wpdb->prefix . "pd_pfd_products";
        if ($wpdb->get_var("show tables like '$table_name'") != $table_name) {
            $sql = "CREATE TABLE " . $table_name . " (
				id mediumint(9) NOT NULL AUTO_INCREMENT,
				name VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,
				file VARCHAR(255) NOT NULL,
				downloads bigint(11) NOT NULL,
				cost bigint(11) NOT NULL,
				created_at bigint(11) DEFAULT '0' NOT NULL,
				PRIMARY KEY id (id)
			);";

            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            dbDelta($sql);
        }

		
		
		
		
        $table_name = $wpdb->prefix . "pd_pfd_orders";
        if ($wpdb->get_var("show tables like '$table_name'") != $table_name) {
            $sql = "CREATE TABLE " . $table_name . " (
				id mediumint(9) NOT NULL AUTO_INCREMENT,
				product_id mediumint(9) NOT NULL,
				order_code VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,
				fulfilled mediumint(9) NOT NULL,
				cost bigint(11) NOT NULL,
				created_at bigint(11) DEFAULT '0' NOT NULL,
				PRIMARY KEY id (id)
			);";

            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            dbDelta($sql);
        }


        $table_name = $wpdb->prefix . "pd_pfd_transactions";
        if ($wpdb->get_var("show tables like '$table_name'") != $table_name) {
            $sql = "CREATE TABLE " . $table_name . " (
				id mediumint(9) NOT NULL AUTO_INCREMENT,
				product_id mediumint(9) NOT NULL,
				order_id mediumint(9) NOT NULL,
				order_code VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,
				protection_eligibility VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				address_status VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				payer_id VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				tax bigint(11) NULL,
				payment_date VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				payment_status VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				first_name VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				last_name VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				payer_status VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				business VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				address_name VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				address_street VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				address_city VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				address_state VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				address_zip VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				address_country_code VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				address_country VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				quantity VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				verify_sign VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				payer_email VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				txn_id VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				payment_type VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				receiver_email VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				receiver_id VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci  NULL,
				txn_type VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				item_name VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				mc_currency VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				item_number VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				residence_country VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				custom VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				receipt_id VARCHAR(255)  NULL,
				transaction_subject VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_persian_ci NULL,
				payment_fee bigint(11) NOT NULL,
				payment_gross bigint(11) NOT NULL,
				created_at bigint(11) DEFAULT '0' NOT NULL,
				PRIMARY KEY id (id)
			);";

            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            dbDelta($sql);
        }

        add_option("pd_pfd_db_version", self::DB_VERSION);
    }

    protected static function get_currency() {
        if (get_option('pd_pd_pfd_currency')) {
            $cc = get_option('pd_pd_pfd_currency');
        } else {
            $cc = "USD";
        }

        return $cc;
    }

    protected static function get_currency_symbol() {
        $cc = self::get_currency();

        return self::$currencies[$cc][1];
    }

    public static function validate_currency($currency) {
        if (!empty(self::$currencies[$currency]))
            return $currency;
        return 'USD';
    }

    public static function admin_init() {
        register_setting('pd_pd_pfd_options', 'pd_pd_email_message');
        register_setting('pd_pd_pfd_options', 'pd_pd_email_message_nofile');
        register_setting('pd_pd_pfd_options', 'pd_expire_links_after', 'intval');
        register_setting('pd_pd_pfd_options', 'pd_paypal_email');

        register_setting('pd_pd_pfd_options', "vip_pasargad_terminal");
        register_setting('pd_pd_pfd_options', "vip_pasargad_username");
        register_setting('pd_pd_pfd_options', "vip_manba_username");

        register_setting('pd_pd_pfd_options', "vip_mellat_terminal");
        register_setting('pd_pd_pfd_options', "vip_mellat_username");
        register_setting('pd_pd_pfd_options', "vip_mellat_password");


        register_setting('pd_pd_pfd_options', "dargah_type");

        register_setting('pd_pd_pfd_options', 'pd_pd_paypal_direct', 'intval');
        register_setting('pd_pd_pfd_options', 'pd_paypal_return_url');
        register_setting('pd_pd_pfd_options', 'pd_get_hamrah');
        register_setting('pd_pd_pfd_options', 'pd_pd_pfd_currency', array(__CLASS__, 'validate_currency'));
    }

    public static function admin_menu() {
        add_menu_page("پرداخت به ازای دانلود درگاه بانک", "پرداخت به ازای دانلود درگاه بانک", 'manage_options', 'dp-file-download', array(__CLASS__, 'admin_dashboard'));

        add_submenu_page('dp-file-download', "پرداخت به ازای دانلود درگاه بانک - محصولات", "محصول", 'manage_options', "dp-file-download-products", array(__CLASS__, 'admin_products_router'));

        add_submenu_page('dp-file-download', "پرداخت به ازای دانلود درگاه بانک - تنظیمات", "تنظيمات", 'manage_options', "dp-file-download-settings", array(__CLASS__, 'admin_settings'));

        add_submenu_page('dp-file-download', "پرداخت به ازای دانلود درگاه بانک - تراکنش ها", "تراکنش ها", 'manage_options', "dp-file-download-transactions", array(__CLASS__, 'admin_transactions'));

        global $submenu;
        $submenu['dp-file-download'][0][0] = 'پشتيباني';
    }

    public static function admin_products_router() {
        $action = '';
        if (!empty($_REQUEST['action'])) {
            $action = $_REQUEST['action'];
        }

        switch ($action) {
            case 'edit':
                return self::admin_products_edit();
                break;
            case 'delete':
                return self::admin_products_delete();
                break;
            case 'add':
                return self::admin_products_add();
                break;
            default:
                return self::admin_products();
        }
    }

    protected static function admin_products_edit() {

        global $wpdb;
        $table_name = $wpdb->prefix . "pd_pfd_products";

        if (isset($_POST["product_name"])) {

            $name = $_POST["product_name"];
            $url = $_POST["product_url"];
            $secondUrl = $_POST["product_second_url"];

            $url = $url . ' | ' . $secondUrl;

            $cost = $_POST["product_cost"];

            $wpdb->update($table_name, array('name' => $name, 'file' => $url, 'cost' => $cost), array('id' => $_GET["id"]), array('%s', '%s', '%s'));
        }

        $product = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE id = %d", $_GET["id"]), ARRAY_A, 0);
        $exp = explode(" | ", $product['file']);
        $product['file'] = $exp[0];
        $product['secondLink'] = $exp[1];
        ?>
        <div class="wrap">
            <h2>ويرايش محصول: <?php echo $product['name'] ?></h2>
            <a href="<?php echo get_option('siteurl'); ?>/wp-admin/admin.php?page=dp-file-download-products">&laquo; بازگشت به صفحه محصولات</a>
            <form action="<?php echo get_option('siteurl'); ?>/wp-admin/admin.php?page=dp-file-download-products&action=edit&id=<?php echo $_GET['id'] ?>" method="post">
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row">نام محصول</th>
                        <td><input type="text" name="product_name" style="width:250px;" value="<?php echo str_replace('"', '\"', $product["name"]); ?>" /></td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">لينک محصول</th>
                        <td><input type="text" name="product_url" style="width:400px;" value="<?php echo str_replace('"', '\"', $product["file"]); ?>" /><br />(لطفا اطمينان حاصل کنيد که اين لينک مخفي است<br />اين لينک پس از خريد موفق به خريدار نشان داده مي شود )<br/>لینک باید به یک فایل اشاره کند.</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">لینک دوم محصول</th>
                        <td><input type="text" name="product_second_url" style="width:400px;" value="<?php echo str_replace('"', '\"', $product["secondLink"]); ?>" /><br />(لطفا اطمينان حاصل کنيد که اين لينک مخفي است<br />اين لينک پس از خريد موفق به خريدار نشان داده مي شود )<br/>لینک باید به یک فایل اشاره کند.</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">قيمت محصول(به ازاي هر بار دانلود)</th>
                        <td><input type="text" name="product_cost" style="width:50px;" value="<?php echo str_replace('"', '\"', $product["cost"]); ?>" />ریال</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">&nbsp;</th>
                        <td>
                            <input type="submit" class="button-primary" value="ذخيره کن" />
                        </td>
                    </tr>
                </table>
            </form>
        </div>
        <?php
    }

    protected static function admin_products_delete() {
        // delete and redirect
        global $wpdb;
        $table_name = $wpdb->prefix . "pd_pfd_products";

        $id = $_GET["id"];

        $wpdb->query("DELETE FROM $table_name WHERE id = '$id'");
        ?>
        <script type="text/javascript">
            <!--
            window.location = "<?php echo get_option('siteurl') . '/wp-admin/admin.php?page=dp-file-download-products' ?>"
                    //-->
        </script>
        <?php
    }

    public static function admin_dashboard() {
        ?>
        <div class="wrap" style="font-size:16px">
            <br /><br /><br />
            هرگونه سوال ، انتقاد و يا پيشنهاد خود را در رابطه با اين پلاگين و يا سامانه پرداخت اينترنتي  ما  را با آدرس زير در ميان بگذاريد
            <br />
            <div align="left" style="font-size:20px"><br /><br />Email: mo.behzad34@gmail.com</div>
        </div>
        <?php
    }

    protected static function admin_products() {
        if (!current_user_can('manage_options')) {
            wp_die(__('You do not have sufficient permissions to access this page.'));
        }
        ?>
        <div class="wrap">
            <h2>محصولات</h2>
            <table class="widefat post fixed" cellspacing="0">
                <thead>
                    <tr>
                        <th scope="col" id="name" width="5%" class="manage-column" style="">رديف</th>
                        <th scope="col" id="name" width="50%" class="manage-column" style="">نام</th>
                        <th scope="col" id="cost" class="manage-column" style="">قيمت</th>
                        <th scope="col" id="downloads" class="manage-column num" style="">تعداد دانلود</th>
                        <th scope="col" id="edit" class="manage-column num" style="">ويرايش</th>
                        <th scope="col" id="delete" class="manage-column num" style="">حذف</th>
                    </tr>
                </thead>

                <tfoot>
                    <tr>
                        <th scope="col" id="name" width="5%" class="manage-column" style="">رديف</th>
                        <th scope="col" id="name" width="50%" class="manage-column" style="">نام</th>
                        <th scope="col" id="cost" class="manage-column" style="">قيمت</th>
                        <th scope="col" id="downloads" class="manage-column num" style="">تعداد دانلود</th>
                        <th scope="col" id="edit" class="manage-column num" style="">ويرايش</th>
                        <th scope="col" id="delete" class="manage-column num" style="">حذف</th>
                    </tr>
                </tfoot>

                <tbody>
                    <?php
                    global $wpdb;
                    $table_name = $wpdb->prefix . "pd_pfd_products";
                    $products = $wpdb->get_results("SELECT * FROM $table_name ORDER BY id ASC", ARRAY_A);
                    if (count($products) == 0) {
                        ?>
                        <tr class='alternate author-self status-publish iedit' valign="top">
                            <td class="" colspan="5">هيچ محصولي موجود نيست</td>
                        </tr>
                        <?php
                    } else {
                        foreach ($products as $product) {
                            ?>
                            <tr class='alternate author-self status-publish iedit' valign="top">
                                <td class=""><?php echo $product['id'] ?></td>
                                <td class="post-title column-title"><strong><a class="row-title" href="<?php echo get_option('siteurl') ?>/wp-admin/admin.php?page=dp-file-download-products&action=edit&id=<?php echo $product['id'] ?>"><?php echo $product['name'] ?></a></strong></td>
                                <td class=""><?php echo $product['cost'] ?> ریال</td>
                                <td class="" style="text-align:center;"><?php echo $product['downloads'] ?></td>
                                <td class="" style="text-align:center;"><a href="<?php echo get_option('siteurl') ?>/wp-admin/admin.php?page=dp-file-download-products&action=edit&id=<?php echo $product['id'] ?>">ويرايش</a></td>
                                <td class="" style="text-align:center;"><a href="<?php echo get_option('siteurl') ?>/wp-admin/admin.php?page=dp-file-download-products&action=delete&id=<?php echo $product['id'] ?>" onclick="if (confirm('آيا از حذف اين مورد اطمينان داريد؟ !')) {
                                                            return true;
                                                        } else {
                                                            return false;
                                                        }">حذف</a></td>
                            </tr>
                            <?php
                        }
                    }
                    ?>
                </tbody>
            </table>

            <h2>اضافه نمودن محصول</h2>
            <form action="<?php echo get_option('siteurl') ?>/wp-admin/admin.php?page=dp-file-download-products&action=add" method="post">
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row">نام محصول</th>
                        <td><input type="text" name="product_name" style="width:250px;" value="" /></td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">لينک محصول</th>
                        <td><input type="text" name="product_url" style="width:400px;" value="" /><br />(لطفا اطمينان حاصل کنيد که اين لينک مخفي است<br />اين لينک پس از خريد موفق به خريدار نشان داده مي شود )<br/>لینک باید به یک فایل اشاره کند.</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">لینک دوم محصول</th>
                        <td><input type="text" name="product_second_url" style="width:400px;" value="" /><br />(لطفا اطمينان حاصل کنيد که اين لينک مخفي است<br />اين لينک پس از خريد موفق به خريدار نشان داده مي شود )<br/>لینک باید به یک فایل اشاره کند.</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">قيمت محصول(به ازاي هر بار دانلود)</th>
                        <td><input type="text" name="product_cost" style="width:50px;" value="" />ریال</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">&nbsp;</th>
                        <td>
                            <input type="submit" class="button-primary" value="اضافه کن" />
                        </td>
                    </tr>
                </table>
            </form>
        </div>
        <?php
    }

    protected static function admin_products_add() {
        // get shit
        $name = $_POST["product_name"];
        $url = $_POST["product_url"];
        $secondUrl = $_POST["product_second_url"];

        $url = $url . ' | ' . $secondUrl;

        $cost = $_POST["product_cost"];

        global $wpdb;
        $table_name = $wpdb->prefix . "pd_pfd_products";

        $wpdb->insert($table_name, array('name' => $name, 'file' => $url, 'cost' => $cost, 'downloads' => 0, 'created_at' => time()), array('%s', '%s', '%s', '%d', '%d'));
        ?>
        <script type="text/javascript">
                    <!--
            window.location = "<?php echo get_option('siteurl') . '/wp-admin/admin.php?page=dp-file-download-products' ?>"
                    //-->
        </script>
        <?php
    }

    public static function admin_settings() {
        if (!current_user_can('manage_options')) {
            wp_die(__('You do not have sufficient permissions to access this page.'));
        }
        ?>
        <div class="wrap">
            <h2>تنظيمات درگاه</h2>
            <?php
            if (isset($_GET['settings-updated'])) {
                echo '<div id="message" class="updated"><p>تنظيمات به روز شد!</p></div>';
            }
            ?>
            <form method="post" action="options.php">
                <?php settings_fields('pd_pd_pfd_options'); ?>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row">شماره پایانه</th>
                        <td><input type="text" name="vip_mellat_terminal" style="width:300px;" value="<?php echo get_option('vip_mellat_terminal'); ?>" />
                            <br />
                            شماره پایانه شما در بانک ملت </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">نام کاربری درگاه شما</th>
                        <td><input type="text" name="vip_mellat_username" style="width:300px;" value="<?php echo get_option('vip_mellat_username'); ?>" />
                            <br />
                            نام کاربری شما در بانک ملت</td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">کلمه عبور درگاه شما</th>
                        <td><input type="text" name="vip_mellat_password" style="width:300px;" value="<?php echo get_option('vip_mellat_password'); ?>" />
                            <br />
                            کلمه عبور شما در بانک ملت</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">شماره پایانه</th>
                        <td><input type="text" name="vip_pasargad_terminal" style="width:300px;" value="<?php echo get_option('vip_pasargad_terminal'); ?>" />
                            <br />
                            شماره پایانه شما در پاسارگاد</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">شماره پذیرنده</th>
                        <td><input type="text" name="vip_pasargad_username" style="width:300px;" value="<?php echo get_option('vip_pasargad_username'); ?>" />
                            <br />
                            کد پذیرنده شما در بانک پاسارگاد</td>
                    </tr>
					
					<tr valign="top">
                        <th scope="row">شماره ترمينال</th>
                        <td><input type="text" name="vip_manba_username" style="width:300px;" value="<?php echo get_option('vip_manba_username'); ?>" />
                            <br />
                           شماره ترمينال پرداخت الکترونیک سپهر</td>
                    </tr>
					
                    <tr valign="top">
                        <th scope="row">درگاه پیش فرض</th> 
                        <td><input type="text" name="dargah_type" style="width:250px;" value="<?php echo get_option('dargah_type'); ?>" /><br />ملت = 1 و پاسارگاد = 0 و الکترونیک سپهر =2 </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">تاريخ انقضاي لينک بعد از...</th>
                        <td><input type="text" name="pd_expire_links_after" style="width:50px;" value="<?php echo get_option('pd_expire_links_after'); ?>" /> روز (0 براي بي نهايت)<br />فعال کردن اين قسمت باعث مي شود لينک هاي شما پس از مدت تعيين شده غير فعال شوند</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">مستقیم کردن لینک دانلود</th>
                        <td><input type="text" name="pd_pd_paypal_direct" style="width:50px;" value="<?php echo get_option('pd_pd_paypal_direct'); ?>" /> (1 به معنای فعال و 0 یعنی غیرفعال)<br />فعال کردن اين قسمت باعث مي شود لينک هاي شما پس از پرداخت بصورت مستقیم نمایش داده شوند</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">گرفتن شماره‌تلفن خریدار؟</th> 
                        <td><input type="text" name="pd_get_hamrah" style="width:250px;" value="<?php echo get_option('pd_get_hamrah'); ?>" /><br />(0 برای نگرفتن و 1 برای گرفتن شماره‌همراه)</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">آدرس بازگشتي</th> 
                        <td><input type="text" name="pd_paypal_return_url" style="width:250px;" value="<?php echo get_option('pd_paypal_return_url'); ?>" /><br />لینک بازگشت به سایت شما بعد از پرداخت</td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">اطلاع رساني</th>
                        <td><textarea name="pd_pd_email_message" style="width:400px;height:200px;"><?php echo get_option('pd_pd_email_message'); ?></textarea><br />پس از خريد موفق اين متن براي خريدار به نمايش در خواهد آمد<br /><strong>لينک دانلود بصورت اتوماتيک در انتهاي اين متن قرار مي گيرد</strong><br />شما مي توانيد از متغير هاي زير استفاده کنيد: <br />[DOWNLOAD_LINK] [PRODUCT_NAME] [TRANSACTION_ID]<br /></td>
                    </tr>
                    <tr valign="top">
                        <th scope="row">&nbsp;</th>
                        <td>
                            <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
                        </td>
                    </tr>
                </table>
            </form>
        </div>
        <?php
    }

    public static function admin_transactions() {
        if (!current_user_can('manage_options')) {
            wp_die(__('You do not have sufficient permissions to access this page.'));
        }
        ?>
        <div class="wrap">
            <h2>تراکنش ها</h2>
            <table class="widefat post fixed" cellspacing="0">
                <thead>
                    <tr>
                        <th scope="col" id="name" width="30%" class="manage-column" style=""> محصول</th>
                        <th scope="col" id="name" width="20%" class="manage-column" style=""> شماره تراکنش</th>
                        <th scope="col" id="name" width="20%" class="manage-column" style="">تاريخ</th>
                        <th scope="col" id="name" width="20%" class="manage-column" style="">ایمیل</th>
                        <th scope="col" id="name" width="20%" class="manage-column" style="">تلفن همراه</th>
                        <th scope="col" id="name" width="20%" class="manage-column" style="">قيمت</th>
                    </tr>
                </thead>

                <tfoot>
                    <tr>
                        <th scope="col" id="name" width="40%" class="manage-column" style="">شماره تراکنش, محصول</th>
                        <th scope="col" id="name" width="20%" class="manage-column" style="">تاريخ</th>
                        <th scope="col" id="name" width="20%" class="manage-column" style="">ایمیل</th>
                        <th scope="col" id="name" width="20%" class="manage-column" style="">تلفن همراه</th>
                        <th scope="col" id="name" width="20%" class="manage-column" style="">قيمت</th>
                    </tr>
                </tfoot>

                <tbody>
                    <?php
                    global $wpdb;
                    $table_name = $wpdb->prefix . "pd_pfd_transactions";
                    $products_name = $wpdb->prefix . "pd_pfd_products";
                    $orders_name = $wpdb->prefix . "pd_pfd_orders";

                    $transactions = $wpdb->get_results("SELECT $table_name.order_code, $products_name.name, $table_name.first_name, $table_name.created_at, $table_name.last_name, $table_name.address_street, $table_name.address_city, $table_name.address_state, $table_name.address_zip, $table_name.address_country, $table_name.payment_fee, $table_name.payer_email, $orders_name.cost FROM $table_name JOIN $products_name ON $table_name.product_id = $products_name.id JOIN $orders_name ON $table_name.order_id = $orders_name.id ORDER BY $table_name.id DESC", ARRAY_A);
                    if (count($transactions) == 0) {
                        ?>
                        <tr class='alternate author-self status-publish iedit' valign="top">
                            <td class="" colspan="7">هيج تراکنش وجود ندارد.</td>
                        </tr>
                        <?php
                    } else {
                        foreach ($transactions as $transaction) {
                            $exploded = explode(" | ", $transaction['payer_email']);
                            $transaction['payer_email'] = wp_specialchars($exploded[0]);
                            $transaction['payer_mobile'] = wp_specialchars($exploded[1]);
                            ?>
                            <tr class='alternate author-self status-publish iedit' valign="top">
                                <td class="post-title column-title"><strong><?php echo $transaction['name'] ?></strong></td>
                                <td class="post-title column-title"><strong><?php echo $transaction['order_code'] ?></strong></td>
                                <td class=""><?php echo strftime("%a, %B %e, %Y %r", $transaction['created_at']) ?><br />(<?php echo self::relative_time($transaction["created_at"]) ?> ago)</td>
                                <td class=""><?php echo $transaction['payer_email'] ?></td>
                                <td class=""><?php echo $transaction['payer_mobile'] ?></td>
                                <td class=""><?php echo $transaction['cost'] ?> ریال</td>
                            </tr>

                            <?php
                        }
                    }
                    ?>
                </tbody>
            </table>
        </div>
        <?php
    }

    public static function media_button($context) {
        $image_url = "http://dargahbank.ir/wd/images/favicon.png";
        $more = '<a href="#TB_inline?width=450&inlineId=dp_paypal_file_download_form" class="thickbox" title="قرارد دادن لينک پرداخت "><img src="' . $image_url . '" alt="قرارد دادن لينک پرداخت " /></a>';
        return $context . $more;
    }

    public static function add_pd_pfd_form() {
        ?>
        <script type="text/javascript">
                    function insert_pd_pfd_button() {
                        product_id = jQuery("#dp_product_selector").val()
                        dp_image = jQuery("#dp_button_image_url").val()

                        //construct = '<a href="<?php echo get_option('siteurl') ?>/?dp_checkout=' + product_id + '"><img src="' + image + '" /></a>';
                        construct = '<form name="frm_dp' + product_id + '" action="<?php echo get_option('siteurl') ?>/?dp_checkout=' + product_id + '" method="post"><input type="image" name="submit" src="' + dp_image + '" value="1"></form>';

                        var wdw = window.dialogArguments || opener || parent || top;
                        wdw.send_to_editor(construct);
                    }

                    function insert_pd_pfd_link() {
                        product_id = jQuery("#dp_product_selector").val()

                        //construct = '<a href="<?php echo get_option('siteurl') ?>/?dp_checkout=' + product_id + '"><?php echo get_option('siteurl') ?>/?checkout=' + product_id + '</a>';
                        construct = '<form name="frm_dp' + product_id + '" action="<?php echo get_option('siteurl') ?>/?dp_checkout=' + product_id + '" method="post"><input type="image" src="" value="' + dp_image + '"></form>';

                        var wdw = window.dialogArguments || opener || parent || top;
                        wdw.send_to_editor(construct);
                    }
        </script>

        <div id="dp_paypal_file_download_form" style="display:none;">
            <div class="wrap">
                <div>
                    <div style="padding:15px 15px 0 15px;">
                        <h3 style="font-size:16pt !important;line-height:1em !important;color:#555555 !important; font-family: Georgia, Times New Roman, Times, serif !important;"><span style="font-weight:normal; ">Dargahbank Download</span><br />قرارد دادن لينک پرداخت درگاه بانک</h3>
                        <span>لطفا محصول مورد نظرتان را از لينک زير انتخاب نماييد</span>
                    </div>
                    <div style="padding:15px 15px 0 15px;">
                        <table width="100%">
                            <tr>
                                <td width="150"><strong>محصول</strong></td>
                                <td>
                                    <select id="dp_product_selector">
                                        <?php
                                        global $wpdb;
                                        $table_name = $wpdb->prefix . "pd_pfd_products";
                                        $products = $wpdb->get_results("SELECT * FROM $table_name ORDER BY id ASC;", ARRAY_A);
                                        if (count($products) == 0) {
                                            ?>
                                            محصولي وجود ندارد. <a href="<?php echo get_option('siteurl') . "/wp-admin/admin.php?page=paypal-file-download-products" ?>">نوشته خود را ذخيره کنيد و سپس اينجا کليک نماييد.</a>
                                            <?php
                                        } else {
                                            foreach ($products as $product) {
                                                ?>
                                                <option value="<?php echo $product["id"] ?>"><?php echo $product["name"] ?> (<?php echo $product["cost"] ?> ریال)</option>
                                                <?php
                                            }
                                        }
                                        ?>
                                    </select>
                                </td>
                            </tr>
                            <tr>
                                <td width="135"><strong>لينک تصوير پرداخت:</strong></td>
                                <td><input type="text" id="dp_button_image_url" value="http://dargahbank.ir/wd/images/logo.png" style="width:220px;" /></td>
                            </tr>
                        </table>
                    </div>

                    <div style="padding:15px;">
                        <input type="button" class="button-primary" value="قرار دادن Button" onclick="insert_pd_pfd_button();"/>&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" class="button" value="قرار دادن لينک" onclick="insert_pd_pfd_link();"/>&nbsp;&nbsp;&nbsp;&nbsp;<a style="font-size:0.9em;text-decoration:none;color:#555555;" href="#" onclick="tb_remove();
                                        return false;">بستن</a>
                    </div>
                </div>
            </div>
        </div>
        <?php
    }

    protected static function ipn() {
        @session_start();
        echo "<br/><div align='center' dir='rtl' style='font-family:tahoma;font-size:12px;'><b>نتیجـــه تـــراکنـش</b></div><br />";

        $this_script = get_option('siteurl');
        $orderid = $_SESSION['orderid'];
        $type = $_SESSION['type'];
        if ($type == 1) {
            include_once 'parser.php';

            $fields = array('invoiceUID' => $_GET['tref']);
            $result = post2https($fields, 'https://pep.shaparak.ir/CheckTransactionResult.aspx');
            $array = makeXMLTree($result);
            $RefId = $_GET['tref'];
            if ($array["resultObj"]["result"] != 'False') {
                require_once("RSAProcessor.class.php");
                $xmllocation = get_option('siteurl') . "/wp-content/plugins/paiddownloaddp_5/key.xml";

                $merchantCode = get_option('vip_pasargad_username'); // كد پذيرنده
                $terminalCode = get_option('vip_pasargad_terminal'); // كد ترمينال

                $fields = array(
                    'MerchantCode' => $merchantCode, //shomare ye moshtari e shoma.
                    'TerminalCode' => $terminalCode, //shomare ye terminal e shoma.
                    'InvoiceNumber' => $orderid, //shomare ye factor tarakonesh.
                    'InvoiceDate' => $_SESSION['time'], //tarikh e tarakonesh.
                    'amount' => $_SESSION['dargahpardakht_fi'], //mablagh e tarakonesh. faghat adad.
                    'TimeStamp' => date("Y/m/d H:i:s"), //zamane jari ye system.
                    'sign' => ''        //reshte ye ersali ye code shode. in mored automatic por mishavad. 
                );

                $processor = new RSAProcessor($xmllocation);

                $data = "#" . $fields['MerchantCode'] . "#" . $fields['TerminalCode'] . "#" . $fields['InvoiceNumber'] . "#" . $fields['InvoiceDate'] . "#" . $fields['amount'] . "#" . $fields['TimeStamp'] . "#";
                $data = sha1($data, true);
                $data = $processor->sign($data);
                $fields['sign'] = base64_encode($data); // base64_encode 

                $sendingData = "MerchantCode=" . $merchantCode . "&TerminalCode=" . $terminalCode . "&InvoiceNumber=" . $invoiceNumber . "&InvoiceDate=" . $invoiceDate . "&amount=" . $amount . "&TimeStamp=" . $timeStamp . "&sign=" . $fields['sign'];
                $verifyresult = post2https($fields, 'https://pep.shaparak.ir/VerifyPayment.aspx');
                $array = makeXMLTree($verifyresult);

                if ($array["resultObj"]["verifyresult"] != 'False') {

                    // find with order id
                    global $wpdb;
                    $table_name = $wpdb->prefix . "pd_pfd_orders";
                    $order = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE order_code = $orderid AND fulfilled = 0", $RefId), ARRAY_A, 0);
                    $wpdb->update($table_name, array('fulfilled' => 1), array('id' => $order["id"]));
                    $table_name = $wpdb->prefix . "pd_pfd_products";
                    $product = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE id = %d", $order["product_id"]), ARRAY_A, 0);
                    $wpdb->update($table_name, array('downloads' => $product["downloads"] + 1), array('id' => $product["id"]));
                    $trans = array();
                    // vars we want to extract
                    /* $fields = "protection_eligibility address_status payer_id tax payment_date payment_status first_name last_name payer_status business address_name address_street address_city address_state address_zip address_country_code address_country quantity verify_sign payer_email txn_id payment_type receiver_email receiver_id txn_type item_name mc_currency item_number residence_country custom receipt_id transaction_subject payment_fee payment_gross";
                      $fields_a = explode(" ",$fields);
                      foreach($fields_a as $field) {
                      $trans[$field] = isset($_POST[$field]) ? $_POST[$field] : NULL;
                      } */
                    $trans["product_id"] = $product["id"];
                    $trans["order_code"] = $orderid;
                    $trans["order_id"] = $order["id"];
                    $trans["payer_email"] = $_SESSION['email'] . ' | ' . $_SESSION['telNo'];
                    $trans["created_at"] = time();
                    // insert into transactions
                    $table_name = $wpdb->prefix . "pd_pfd_transactions";
                    $wpdb->insert($table_name, $trans);
                    if (get_option("pd_pd_paypal_direct") == 1) {
                        //&linkNo = 1
                        $download_link = $product["file"];
                        $expld = explode(" | ", $download_link);
                        $download_link = $expld[0];
                        $download_name = $product["name"];
                        $download_link = "<a href='$download_link' target=\"_blank\">$download_name</a>";
                    } else {
                        $download_link = get_option('siteurl') . "/?dp_download=" . urlencode($trans_id);
                        $download_link = "<a href='$download_link&dp_linkNo=1' target=\"_blank\">$download_link</a>";
                    }

                    // get email text
                    $emailtext = get_option('pd_pd_email_message');
                    $emailtext = str_replace("[DOWNLOAD_LINK]", $download_link, $emailtext);
                    $emailtext = str_replace("[PRODUCT_NAME]", $product["name"], $emailtext);
                    $emailtext = str_replace("[TRANSACTION_ID]", $orderid, $emailtext);
                    $emailtext = $emailtext . "<br /><br />لينک دانلود شما:<br />" . $download_link;
                    // fantastic, now send them a message
                    $message = $emailtext;
                    echo "<div align='center' dir='rtl' style='font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%'>تراکنش شما <font color='green'><b>مـوفق بود</b></font>.<br/><p align='right' style='margin-right:15px'>" . nl2br($message) . "</p><a href='", ('http://www.rroyale.ir'), "'></a><br/><br/></div>";
                    $headers = "From: <no-reply>\n";
                    $headers .= "MIME-Version: 1.0\n";
                    $headers .= 'Content-type: text/html; charset=utf-8' . "\r\n";

                    mail($_SESSION['email'], 'اطلاعات پرداخت', $emailtext, $headers);
                } else {
                    echo "<div align='center' dir='rtl' style='font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%'>تراکنش شما <font color='red'><b>نـاموفق بود</b></font>.
			<br/><p align='right' style='margin-right:15px'> ممکن است به علت یکی از دلایل زیر باشد
			<br/>1- ممکن است ارتباط شما با دروازه پرداخت بانک برقرار نشده باشد
			<br/>2- ممکن است از انجام عملیات پرداخت منصرف شده باشید
			<br/>3- ممکن است سرعت اینترنت شما کم باشد.
			<br/> لطفا به صفحه اصلی سایت بازگشته و مجددا خرید خود را انجام دهید.
			</p><a href='", ('http://www.rroyale.ir'), "'>بازگشت به صفحه اصلي</a><br/><br/></div>";
                }
            } else {
                echo "<div align='center' dir='rtl' style='font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%'>تراکنش شما <font color='red'><b>نـاموفق بود</b></font>.
			<br/><p align='right' style='margin-right:15px'> ممکن است به علت یکی از دلایل زیر باشد
			<br/>1- ممکن است ارتباط شما با دروازه پرداخت بانک برقرار نشده باشد
			<br/>2- ممکن است از انجام عملیات پرداخت منصرف شده باشید
			<br/>3- ممکن است سرعت اینترنت شما کم باشد.
			<br/> لطفا به صفحه اصلی سایت بازگشته و مجددا خرید خود را انجام دهید.
			</p><a href='", ('http://www.rroyale.ir'), "'>بازگشت به صفحه اصلي</a><br/><br/></div>";
            }
        } else if ($type == 0) {
            //bank mellat here
            $orderid = $_SESSION['orderid'];
            //bank mellat begin
            $RefId = $_POST['RefId'];
            $ResCode = $_POST['ResCode'];
            $saleOrderId = $_POST['SaleOrderId'];
            $SaleReferenceId = $_POST['SaleReferenceId'];


            if ($ResCode == 0) {
                include_once 'nusoap.php';
                include_once 'mellat.php';

                $terminalid = get_option('vip_mellat_terminal');
                $userName = get_option('vip_mellat_username');
                $userPassword = get_option('vip_mellat_password');

                $client = new nusoap_client('https://bpm.shaparak.ir/pgwchannel/services/pgw?wsdl');
                $Mellat = new Mellat($client, $terminalid, $userName, $userPassword);

                $resultVerify = $Mellat->Verify($RefId, $saleOrderId, $SaleReferenceId);
                if ($resultVerify == TRUE) {
                    $resultStr = $Mellat->Settle($RefId, $saleOrderId, $SaleReferenceId);
                    if ($resultStr == TRUE) {
                        // find with order id
                        global $wpdb;
                        $table_name = $wpdb->prefix . "pd_pfd_orders";
                        $order = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE order_code = $orderid AND fulfilled = 0", $RefId), ARRAY_A, 0);
                        $wpdb->update($table_name, array('fulfilled' => 1), array('id' => $order["id"]));
                        $table_name = $wpdb->prefix . "pd_pfd_products";
                        $product = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE id = %d", $order["product_id"]), ARRAY_A, 0);
                        $wpdb->update($table_name, array('downloads' => $product["downloads"] + 1), array('id' => $product["id"]));
                        $trans = array();
                        // vars we want to extract
                        /* $fields = "protection_eligibility address_status payer_id tax payment_date payment_status first_name last_name payer_status business address_name address_street address_city address_state address_zip address_country_code address_country quantity verify_sign payer_email txn_id payment_type receiver_email receiver_id txn_type item_name mc_currency item_number residence_country custom receipt_id transaction_subject payment_fee payment_gross";
                          $fields_a = explode(" ",$fields);
                          foreach($fields_a as $field) {
                          $trans[$field] = isset($_POST[$field]) ? $_POST[$field] : NULL;
                          } */
                        $trans["product_id"] = $product["id"];
                        $trans["order_code"] = $orderid;
                        $trans["order_id"] = $order["id"];
                        $trans["payer_email"] = $_SESSION['email'] . ' | ' . $_SESSION['telNo'];
                        $trans["created_at"] = time();
                        // insert into transactions
                        $table_name = $wpdb->prefix . "pd_pfd_transactions";
                        $wpdb->insert($table_name, $trans);
                        // download link
                        if (get_option("pd_pd_paypal_direct") == 1) {
                            //&linkNo = 1
                            $download_link = $product["file"];
                            $expld = explode(" | ", $download_link);
                            $download_link = $expld[0];
                            $download_name = $product["name"];
                            $download_link = "<a href='$download_link' target=\"_blank\">$download_name</a>";
                        } else {
                            $download_link = get_option('siteurl') . "/?dp_download=" . urlencode($orderid);
                            $download_link = "<a href='$download_link&dp_linkNo=1' target=\"_blank\">$download_link</a>";
                        }

                        // get email text
                        $emailtext = get_option('pd_pd_email_message');
                        $emailtext = str_replace("[DOWNLOAD_LINK]", $download_link, $emailtext);
                        $emailtext = str_replace("[PRODUCT_NAME]", $product["name"], $emailtext);
                        $emailtext = str_replace("[TRANSACTION_ID]", $orderid, $emailtext);
                        $emailtext = $emailtext . "<br /><br />لينک دانلود شما:<br />" . $download_link;
                        // fantastic, now send them a message
                        $message = $emailtext;
                        echo "<div align='center' dir='rtl' style='font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%'>تراکنش شما <font color='green'><b>مـوفق بود</b></font>.<br/><p align='right' style='margin-right:15px'>" . nl2br($message) . "</p><a href='", ('http://www.rroyale.ir'), "'></a><br/><br/></div>";
                        $headers = "From: <no-reply>\n";
                        $headers .= "MIME-Version: 1.0\n";
                        $headers .= 'Content-type: text/html; charset=utf-8' . "\r\n";

                        mail($_SESSION['email'], 'اطلاعات پرداخت', $emailtext, $headers);
                    } else {
                        echo "<div align='center' dir='rtl' style='font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%'>تراکنش شما <font color='red'><b>نـاموفق بود</b></font>.<br/><p align='right' style='margin-right:15px'> ممکن است به یکی از دلایل زیر باشد:<br/>1- ممکن است ارتباط شما با دروازه پرداخت بانک برقرار نشده باشد<br/>2- ممکن است از انجام عملیات پرداخت منصرف شده باشید<br/>3- ممکن است سرعت اینترنت شما درحال حاضر کم باشد و قادر به باز کردن درگاه پرداخت بانک نباشید.<br/> لطفا به صفحه اصلی سایت بازگشته و مجددا خرید خود را انجام دهید.</p><a href='", ('http://www.rroyale.ir'), "'>بازگشت به صفحه اصلي</a><br/><br/></div>";
                    }
                } else {
                    echo "<div align='center' dir='rtl' style='font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%'>تراکنش شما <font color='red'><b>نـاموفق بود</b></font>.<br/><p align='right' style='margin-right:15px'> ممکن است به یکی از دلایل زیر باشد:<br/>1- ممکن است ارتباط شما با دروازه پرداخت بانک برقرار نشده باشد<br/>2- ممکن است از انجام عملیات پرداخت منصرف شده باشید<br/>3- ممکن است سرعت اینترنت شما درحال حاضر کم باشد و قادر به باز کردن درگاه پرداخت بانک نباشید.<br/> لطفا به صفحه اصلی سایت بازگشته و مجددا خرید خود را انجام دهید.</p><a href='", ('http://www.rroyale.ir'), "'>بازگشت به صفحه اصلي</a><br/><br/></div>";
                }
            } else {
                echo "<div align='center' dir='rtl' style='font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%'>تراکنش شما <font color='red'><b>نـاموفق بود</b></font>.
			<br/><p align='right' style='margin-right:15px'> ممکن است به علت یکی از دلایل زیر باشد
			<br/>1- ممکن است ارتباط شما با دروازه پرداخت بانک برقرار نشده باشد
			<br/>2- ممکن است از انجام عملیات پرداخت منصرف شده باشید
			<br/>3- ممکن است سرعت اینترنت شما کم باشد.
			<br/>4- کد خطا : " . $result . "
			<br/> لطفا به صفحه اصلی سایت بازگشته و مجددا خرید خود را انجام دهید.
			</p><a href='", ('http://www.rroyale.ir'), "'>بازگشت به صفحه اصلي</a><br/><br/></div>";
            }
        }elseif ($type == 2) 
		{
			
			if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
			{
				$terminal = get_option('vip_manba_username');
				$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
				curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
				$result = json_decode($res,true);
				if (strtoupper($result['Status']) == 'OK') 
				{
					 $amount = $_SESSION['dargahpardakht_fi'];
					if($result['ReturnId'] == $amount)
					{
						$RefId = $_POST['invoiceid'];
						$orderid = $_SESSION['orderid'];
                        global $wpdb;
                        $table_name = $wpdb->prefix . "pd_pfd_orders";
                        $order = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE order_code = $orderid AND fulfilled = 0", $RefId), ARRAY_A, 0);
                        $wpdb->update($table_name, array('fulfilled' => 1), array('id' => $order["id"]));
                        $table_name = $wpdb->prefix . "pd_pfd_products";
                        $product = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE id = %d", $order["product_id"]), ARRAY_A, 0);
                        $wpdb->update($table_name, array('downloads' => $product["downloads"] + 1), array('id' => $product["id"]));
                        $trans = array();
                        
                        $trans["product_id"] = $product["id"];
                        $trans["order_code"] = $orderid;
                        $trans["order_id"] = $order["id"];
                        $trans["payer_email"] = $_SESSION['email'] . ' | ' . $_SESSION['telNo'];
                        $trans["created_at"] = time();
                        // insert into transactions
                        $table_name = $wpdb->prefix . "pd_pfd_transactions";
                        $wpdb->insert($table_name, $trans);
                        // download link
                        if (get_option("pd_pd_paypal_direct") == 1) {
                            //&linkNo = 1
                            $download_link = $product["file"];
                            $expld = explode(" | ", $download_link);
                            $download_link = $expld[0];
                            $download_name = $product["name"];
                            $download_link = "<a href='$download_link' target=\"_blank\">$download_name</a>";
                        } else {
                            $download_link = get_option('siteurl') . "/?dp_download=" . urlencode($orderid);
                            $download_link = "<a href='$download_link&dp_linkNo=1' target=\"_blank\">$download_link</a>";
                        }

                        // get email text
                        $emailtext = get_option('pd_pd_email_message');
                        $emailtext = str_replace("[DOWNLOAD_LINK]", $download_link, $emailtext);
                        $emailtext = str_replace("[PRODUCT_NAME]", $product["name"], $emailtext);
                        $emailtext = str_replace("[TRANSACTION_ID]", $orderid, $emailtext);
                        $emailtext = $emailtext . "<br /><br />لينک دانلود شما:<br />" . $download_link;
                        // fantastic, now send them a message
                        $message = $emailtext;
                        echo "<div align='center' dir='rtl' style='font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%'>تراکنش شما <font color='green'><b>مـوفق بود</b></font>.<br/><p align='right' style='margin-right:15px'>" . nl2br($message) . "</p><a href='", ('http://www.rroyale.ir'), "'></a><br/><br/></div>";
                        $headers = "From: <no-reply>\n";
                        $headers .= "MIME-Version: 1.0\n";
                        $headers .= 'Content-type: text/html; charset=utf-8' . "\r\n";

                        mail($_SESSION['email'], 'اطلاعات پرداخت', $emailtext, $headers);
					}else
					{
						echo "<div align='center' dir='rtl' style='font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%'>تراکنش شما <font color='red'><b>نـاموفق بود</b></font>.
						<br/><p align='right' style='margin-right:15px'> ممکن است به علت یکی از دلایل زیر باشد
						<br/>1- ممکن است ارتباط شما با دروازه پرداخت بانک برقرار نشده باشد
						<br/>2- ممکن است از انجام عملیات پرداخت منصرف شده باشید
						<br/>3- ممکن است سرعت اینترنت شما کم باشد.
						<br/>4- کد خطا : مبلغ با قیمت محصول برابر نیست
						<br/> لطفا به صفحه اصلی سایت بازگشته و مجددا خرید خود را انجام دهید.
						</p><a href='", ('http://www.rroyale.ir'), "'>بازگشت به صفحه اصلي</a><br/><br/></div>";
					}
				}
			}
			else 
			{
                echo "<div align='center' dir='rtl' style='font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%'>تراکنش شما <font color='red'><b>نـاموفق بود</b></font>.
			<br/><p align='right' style='margin-right:15px'> ممکن است به علت یکی از دلایل زیر باشد
			<br/>1- ممکن است ارتباط شما با دروازه پرداخت بانک برقرار نشده باشد
			<br/>2- ممکن است از انجام عملیات پرداخت منصرف شده باشید
			<br/>3- ممکن است سرعت اینترنت شما کم باشد.
			<br/>4- کد خطا : " . $_POST['respmsg'] . "
			<br/> لطفا به صفحه اصلی سایت بازگشته و مجددا خرید خود را انجام دهید.
			</p><a href='", ('http://www.rroyale.ir'), "'>بازگشت به صفحه اصلي</a><br/><br/></div>";
		}
    }
	}

    protected static function get_email() {
        echo "<br/><div align='center' dir='rtl' style='font-family:tahoma;font-size:12px;'><b>اطلاعات تکمیلی</b></div><br />";
        @session_start();
        if (get_option('pd_get_hamrah') == '1') {
            $shomareTel = '<tr>
			<td>شماره همراه: </td><td><input type="text" name="telNo" id="telNo" required value="' . $_POST['telNo'] . '" /> </td>
		</tr>';
        } else
            $shomareTel = '';
        echo '<div align="center" dir="rtl" style="font-family:tahoma;font-size:11px;border:1px dotted #c3c3c3; width:60%; line-height:20px;margin-left:20%"><form name="frm1" method="post">
		<table>
		<tr>
			<td>شماره موبایل : </td><td><input type="text" name="email" id="email" required value="' . $_POST['email'] . ' " /> </td>
		</tr>
		' . $shomareTel .
        '
		<tr>
			<td></td><td><input type="submit" name="submitp" value="پرداخت" style="font-family:tahoma"/></td>
		</tr>
		</table>
		</form>
		</div><div style="display:none">
		';
    }
	
    public static function var_listener() {
        if (get_query_var("dp_checkout") == NULL) {
            if (get_query_var("dp_download") == NULL) {
                if (get_query_var("pd_pfd_action") == "ipn") {
                    self::ipn();
                    exit();
                }
            } else {
                $id = $_GET["dp_download"];
                if ($_GET['dp_linkNo'] == '1')
                    $part = 0;
                else
                    $part = 1;
                global $wpdb;
                $table_name = $wpdb->prefix . "pd_pfd_transactions";
                $transaction = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE order_code = %s", $id), ARRAY_A, 0);
                if ($transaction == NULL) {
                    die("فايل مورد نظر يافت نشد.");
                } else {
                    $table_name = $wpdb->prefix . "pd_pfd_products";
                    $product = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE id = %d", $transaction["product_id"]), ARRAY_A, 0);
                    // get option for days
                    $daysexpire = get_option('pd_expire_links_after');
                    if ($daysexpire == 0) {
                        // don't check
                    } else {
                        // check for expiry
                        // transaction created at should be larger than now - x days
                        $nowminus = time() - ($daysexpire * 86400);
                        if ($transaction["created_at"] > $nowminus) {
                            // good
                        } else {
                            die("مدت زمان دانلود اين فايل به اتمام رسيده است.");
                        }
                    }

                    // force download
                    $expld = explode(" | ", $product['file']);
                    $product['file'] = $expld[$part];

                    header('Content-disposition: attachment; filename=' . basename($product["file"]));
                    header('Content-Type: application/octet-stream');
                    header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                    header('Expires: 0');



                    $result = wp_remote_get($product["file"]);

                    echo $result['body'];
                    die();
                }
            }
        } else {
            @session_start();
            if (isset($_POST['submitp'])) {
                if (strlen($_POST['email']) > 2) {
                    $_SESSION['email'] = $_POST['email'];
                } else {
                    $_SESSION['email'] = 'no email';
                }
                $email = $_SESSION['email'];
                $_SESSION['telNo'] = $_POST['telNo'];
                $product_id = get_query_var("dp_checkout");
                $payer_mail = $email;
                global $wpdb;
                $table_name = $wpdb->prefix . "pd_pfd_products";

                // get product
                $product = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE id = %d", $product_id), ARRAY_A, 0);

                // construct order
                $table_name = $wpdb->prefix . "pd_pfd_orders";
                $orderId = $product['id'] . time();
                $_SESSION['orderid'] = $orderId;
                $desc = "خرید محصول " . $product['name'] . 'توسط ' . $_email;

                $amount = $product["cost"];
                $redirect = get_option('siteurl') . "/?pd_pfd_action=ipn";
                $_SESSION['dargahpardakht_fi'] = $amount;
                $xmllocation = get_option('siteurl') . "/wp-content/plugins/paiddownloaddp_5/key.xml";
                $type = get_option('dargah_type');
                $_SESSION['type'] = $type;
                if ($type == 0) {
                    //bank mellat begin
                    include_once 'nusoap.php';
                    include_once 'mellat.php';

                    $terminalid = get_option('vip_mellat_terminal');
                    $userName = get_option('vip_mellat_username');
                    $userPassword = get_option('vip_mellat_password');

                    $client = new nusoap_client('https://bpm.shaparak.ir/pgwchannel/services/pgw?wsdl');
                    $Mellat = new Mellat($client, $terminalid, $userName, $userPassword);

                    $result = $Mellat->Pay($amount, $redirect, $orderId, $desc);
                    if ($result != FALSE) {
                        echo '<html><head><titile><center><b>در حال اتصال به درگاه بانک ملت</b></center></title><script language="javascript" type="text/javascript">
                            function postRefId (refIdValue) {
                           var form = document.createElement("form");
                            form.setAttribute("method", "POST");
                           form.setAttribute("action", "https://bpm.shaparak.ir/pgwchannel/startpay.mellat");
                            form.setAttribute("target", "_self");
                            var hiddenField = document.createElement("input");
                            hiddenField.setAttribute("name", "RefId");
                            hiddenField.setAttribute("value", refIdValue);
                            form.appendChild(hiddenField);

                            document.body.appendChild(form);
                            form.submit();
                            document.body.removeChild(form);
                            }
                            </script></head><body>';
                        $wpdb->insert($table_name, array('product_id' => $product_id, 'order_code' => $orderId, 'fulfilled' => 0, 'created_at' => time(), 'cost' => $product["cost"]), array('%d', '%s', '%d', '%d', '%s'));
                        echo '<center><label>لطفا منتظر بمانید</label></center>';
                        echo "<script language='javascript' type='text/javascript'>postRefId('" . $result . "');</script></body></html>";
                        exit();
                    } else {
                        echo 'خطا در اتصال به درگاه';
                        exit();
                    }
                } else if ($type == 1) {
                    require_once("RSAProcessor.class.php");

                    $processor = new RSAProcessor($xmllocation);
                    $merchantCode = get_option('vip_pasargad_username'); // كد پذيرنده
                    $terminalCode = get_option('vip_pasargad_terminal'); // كد ترمينال

                    $timeStamp = date("Y/m/d H:i:s");
                    $invoiceDate = date("Y/m/d H:i:s"); //تاريخ فاكتور
                    $_SESSION['time'] = $invoiceDate;
                    $action = "1003";  // 1003 : براي درخواست خريد 
                    $data = "#" . $merchantCode . "#" . $terminalCode . "#" . $orderId . "#" . $invoiceDate . "#" . $amount . "#" . $redirect . "#" . $action . "#" . $timeStamp . "#";
                    $data = sha1($data, true);
                    $data = $processor->sign($data); // امضاي ديجيتال 
                    $result = base64_encode($data); // base64_encode 
                    $wpdb->insert($table_name, array('product_id' => $product_id, 'order_code' => $orderId, 'fulfilled' => 0, 'created_at' => time(), 'cost' => $product["cost"]), array('%d', '%s', '%d', '%d', '%s'));
                    echo"<center><label><b>در حال اتصال به درگاه بانک پاسارگاد</b></label></center>
        `           <form action='https://pep.shaparak.ir/gateway.aspx' name='frm' id='frm' method='post'>
                        <input type='hidden' name='invoiceNumber' value='$orderId' /><br />
                        <input type='hidden' name='invoiceDate' value='$invoiceDate' /><br />
                        <input type='hidden' name='amount' value='$amount'/><br />
                        <input type='hidden' name='terminalCode' value='$terminalCode' /><br />
                        <input type='hidden' name='merchantCode' value='$merchantCode' /><br />
                        <input type='hidden' name='redirectAddress' value='$redirect' /><br />
                        <input type='hidden' name='timeStamp' value='$timeStamp' /><br />
                        <input type='hidden' name='action' value='$action' /><br />
                        <input type='hidden' name='sign' value='$result' /><br />
                    </form>";
                    echo'
                    <script language="javascript" type="text/javascript">
                         document.frm.submit();
                    </script>';

                    exit();
                }elseif($type == 2)
				{
					$wpdb->insert($table_name, array('product_id' => $product_id, 'order_code' => $orderId, 'fulfilled' => 0, 'created_at' => time(), 'cost' => $product["cost"]), array('%d', '%s', '%d', '%d', '%s'));
					$terminal = get_option('vip_manba_username'); 
					$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirect).'&invoiceID='.$orderId;
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/GetToken');
					curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					$res = curl_exec($ch);
					curl_close($ch);
					if($res)
					{
						$res = json_decode($res,true);
						if($res['Status'] == '0')
						{	  
						echo	$setPayment = '<form id="paymentUTLfrm" action="https://mabna.shaparak.ir:8080" method="POST">
								<input type="hidden" id="TerminalID" name="TerminalID" value="'.$terminal.'">
								<input type="hidden" id="token" name="token" value="'.$res['Accesstoken'].'">
								</form><script>
								function submitmabna() {
								document.getElementById("paymentUTLfrm").submit();
								}
								window.onload=submitmabna; </script>';die;
						}else
						{
							echo $setPayment =('خطا در ساخت توکن <br/> کد خطا :'.$res['Status']);
						}
					}
					else
					{
						echo $setPayment = ('پورت 8081 در هاست شما بسته است !');
					}
				}
            } else {
                self::get_email();
                exit();
            }
        }
    }

    // make sure we have the paypal action listener available
    public static function register_vars($vars) {
        $vars[] = "pd_pfd_action";
        $vars[] = "dp_checkout";
        $vars[] = "dp_download";
        $vars[] = "dp_linkNo";
        return $vars; // return to wordpress
    }

}
